#pragma once
#include <string>
#include <map>
#include "cookie.h"
#include "simple_http_defs.h"

namespace simple_http
{
	class cookie_manager
	{
	public:
		void add_cookie(const std::string& name, const cookie& value);
		void remove_cookie(const std::string& name, const std::string& domain = "", const std::string& path = "");
		void remove_expired_cookies();
		void remove_session_cookies();
		void add_replace_cookie(const std::string& name, const cookie& value);
		void get_cookies(std::map<std::string, cookie>& cookies, const std::string& domain, const std::string& path = "/", connection_type connection = connection_dont_care) const;
		std::string get_cookies(const std::string& domain, const std::string& path = "/", connection_type connection = connection_dont_care) const;
		void clear_cookies();
		std::size_t total_count() const;

	private:
		std::multimap<std::string, cookie> cookies_;
	};
}
