#pragma once
#include <string>

namespace simple_http
{
	class http_endpoint
	{
	public:
		http_endpoint(const std::string& address, unsigned short port = 80, bool ssl = false);
		static http_endpoint from_string(const std::string& full_name);

		std::string address() const;
		unsigned short port() const;
		bool ssl() const;
		
		void address(const std::string& address);
		void port(unsigned short port);
		void ssl(bool ssl);


		std::string uri() const;
		std::string parameters() const;

		void uri(const std::string& uri);
		void parameters(const std::string& parameters);

	private:
		std::string address_;
		unsigned short port_;
		bool ssl_;

		std::string uri_;
		std::string parameters_;
	};
}
