#pragma once
#include <string>
#include <stdexcept>

namespace simple_http
{
	class http_error : public std::runtime_error
	{
	public:
		enum error_code
		{
			cannot_connect,
			cannot_resolve,
			socks5_authorization_error,
			socks5_site_connection_error,
			cannot_connect_to_http_proxy,
			cannot_connect_to_socks5_proxy,
			socks5_auth_required,
			socks5_too_long_login_or_password,
			error_opening_multipart_file,
			ssl_handshake_error,
			error_writing_to_socket,
			error_reading_from_socket,
			cannot_connect_to_https_proxy,
			cannot_authorize_to_https_proxy,
			timeout,
			ssl_not_supported,
			incorrect_http_endpoint
		};

		http_error(const std::string& message, error_code code);

		virtual ~http_error() throw();
	private:
		error_code code_;
	};
}
