#pragma once
#include <string>

namespace simple_http
{
	class multipart_file_impl;
	class multipart_file
	{
	public:
		multipart_file(const std::string& name, const std::string& filepath);
		multipart_file(const std::string& name, const std::wstring& filepath);
		multipart_file(const std::string& name, const char* binary_data, unsigned long length);
		unsigned long read_data(char* data, unsigned long length = 1024);
		void reset_pointer();
		unsigned long get_length() const;
		std::string get_name() const;
		void close();
		~multipart_file();
	private:
		multipart_file(const multipart_file&);
		multipart_file& operator=(const multipart_file&);
		multipart_file_impl* impl;
	};
}
