#pragma once
#include <boost/asio/io_service.hpp>
#include <boost/asio/ip/tcp.hpp>

namespace simple_http
{
	class socket_not_encrypted
	{
	public:
		socket_not_encrypted(boost::asio::io_service& ios);

		template<typename Handler>
		void async_connect(const boost::asio::ip::tcp::endpoint& ep, const Handler& handler)
		{
			socket_.async_connect(ep, handler);
		}

		template<typename ConstBufferSequence, typename Handler>
		void async_write_some(const ConstBufferSequence& buf, const Handler& handler)
		{
			socket_.async_write_some(buf, handler);
		}

		template<typename MutableBufferSequence, typename Handler>
		void async_read_some(const MutableBufferSequence& buf, const Handler& handler)
		{
			socket_.async_read_some(buf, handler);
		}

		boost::asio::basic_socket<boost::asio::ip::tcp, boost::asio::stream_socket_service<boost::asio::ip::tcp> >& connect_socket()
		{
			return socket_;
		}

		template<typename Handler>
		void async_handshake(const Handler& handler)
		{
			handler(boost::system::error_code());
		}

		boost::asio::ip::tcp::socket& base_socket()
		{
			return socket_;
		}

	private:
		boost::asio::ip::tcp::socket socket_;
	};
}
