#pragma once
#ifdef SSL_SUPPORT
#include <boost/asio/io_service.hpp>
#include <boost/asio/ip/tcp.hpp>
#include <boost/asio/ssl.hpp>

namespace simple_http
{
	class socket_ssl
	{
	public:
		socket_ssl(boost::asio::io_service& ios);

		template<typename Handler>
		void async_connect(const boost::asio::ip::tcp::endpoint& ep, const Handler& handler)
		{
			socket_.lowest_layer().async_connect(ep, handler);
		}

		template<typename ConstBufferSequence, typename Handler>
		void async_write_some(const ConstBufferSequence& buf, const Handler& handler)
		{
			socket_.async_write_some(buf, handler);
		}

		template<typename MutableBufferSequence, typename Handler>
		void async_read_some(const MutableBufferSequence& buf, const Handler& handler)
		{
			socket_.async_read_some(buf, handler);
		}

		boost::asio::basic_socket<boost::asio::ip::tcp, boost::asio::stream_socket_service<boost::asio::ip::tcp> >& connect_socket();

		boost::asio::ip::tcp::socket& base_socket()
		{
			return base_sock_;
		}

		template<typename Handler>
		void async_handshake(const Handler& handler)
		{
			socket_.async_handshake(boost::asio::ssl::stream_base::client, handler);
		}

	private:
		boost::asio::ip::tcp::socket base_sock_;
		boost::asio::ssl::context context_;
		boost::asio::ssl::stream<boost::asio::ip::tcp::socket&> socket_;
	};
}

#endif
