#include <boost/regex.hpp>
#include <boost/thread/mutex.hpp>
#include "static_data.h"

namespace simple_http
{
	const boost::regex cookie_regex("Set-Cookie: (([a-zA-Z0-9]*?)=(.*?);)(.*?)(\n|$)", boost::regex::icase);
	const boost::regex cookie_param_regex("[ ]*(Comment|Version|Expires|Path|Domain|Max\\-Age|HttpOnly|Secure)(=(.*?))?;", boost::regex::icase);
	const boost::regex cookie_expiry_date("[a-zA-Z]{3,20}, (\\d+)(?:\\-| )([a-zA-Z]{3})(?:\\-| )(\\d+) (\\d+):(\\d+):(\\d+) GMT");
	const boost::regex header_regex("^([a-zA-Z0-9\\-]+):[ ]*(.+?)$");
	const boost::regex domain_regex("^(\\.?[a-zA-Z0-9\\-]+){1,30}");
	const boost::regex ip_address_regex("^(\\d+)\\.(\\d+)\\.(\\d+)\\.(\\d+)$");

	const boost::regex full_name_regex("^(http|https)://([a-z][a-z0-9\\-]*(?:\\.[a-z][a-z0-9\\-]*)*)(:\\d{1,5})?(?:(/.*?)(\\?.*)?)?$", boost::regex::icase);
	const boost::regex full_name_ip_regex("^(http|https)://(\\d+(?:\\.\\d+){3})(:\\d{1,5})?(/)?$", boost::regex::icase);
	
	const boost::regex headers_end_regex("\r\n\r\n|\n\n");

	boost::mutex static_mutex;
}
