#pragma once
#include <string>

namespace simple_http
{
	namespace utils
	{
		tm cookie_date_to_tm(const std::string& cookie_date);
		std::string text_to_base64(const std::string& text);
		std::string data_to_base64(const char* data, unsigned long length);
		std::string urlencode_ansi(const std::string& s);
		std::string urlencode_utf8(const std::string& s);
		std::string base64_to_data(const std::string& base64);
		std::string get_path_from_uri(const std::string& uri);
		std::string urlencode_param_string_ansi(const std::string& parameters);
		std::string urlencode_param_string_utf8(const std::string& parameters);
		std::string urlencode_param_string_unicode(const std::wstring& parameters);
		bool is_ip_address(const std::string& domain);
	}
}
